$.ajax = function () {
    return {
        done: function (cb) {
            cb({"data": ["a", "b", "c", "d", "e"]});
        }
    };
};

describe('server', function() {
    it('should fetch the data and build the list with 5 items', function() {
        var xhr = sinon.useFakeXMLHttpRequest();
        var requests = [];

        xhr.onCreate = function (xhr) {
            requests.push(xhr);
        };


        $('body').append('<ul id="itemList"></ul>');
        fetchAndInsert();

        requests[0].respond(200, { "Content-Type": "application/json" },
            '{"data":["a","b","c","d","e"]}');

        expect($('#itemList li').length).toEqual(5);
        $('#itemList').remove();
        xhr.restore();
    });

    it('should fetch the data and build the list with 5 items', function() {
        var server = sinon.fakeServer.create();

        server.respondWith("GET", "/url/on/server",
            [200, { "Content-Type": "application/json" },
                '{"data":["a","b","c","d","e"]}']);

        $('body').append('<ul id="itemList"></ul>');
        fetchAndInsert();

        server.respond();

        expect($('#itemList li').length).toEqual(5);
        $('#itemList').remove();
        server.restore();
    });
});
