describe('timer', function() {

    beforeEach(function() {
        var tpl = '<div id="msg">Some Information</div>';
        $('body').append(tpl);
    });

    afterEach(function() {
        $('#msg').remove();
    });

    it('should hide the message', function() {
        hide();
        expect($('#msg').css('display')).toEqual('none');
    });

    it('should hide the message after 5 sec', function(done) {
        delayedHide();
        setTimeout(function() {
            expect($('#msg').css('display')).toEqual('none');
            done();
        }, 5001);
    });


    it('should hide the message after 5 sec', function() {
        jasmine.clock().install();
        delayedHide();
        jasmine.clock().tick(5001);
        expect($('#msg').css('display')).toEqual('none');
        jasmine.clock().uninstall();
    });

    it('should hide the message after 5 sec', function() {
        var timer = sinon.useFakeTimers();
        delayedHide();
        timer.tick(5001);
        expect($('#msg').css('display')).toEqual('none');
        timer.restore();
    });


});

function setTimeout(cb) {
    cb();
}
