describe('cityList', function() {
    it('should return an object, if an array is given', function() {
        var addresses = [{
            city: 'München'
        }];

        var expected = {
            'München': 1
        };

        var cityList = new CityList(addresses);
        var list = cityList.getList();
        expect(list).toEqual(expected);
    });

    it('should return an object with two properties for two addresses', function() {
        var addresses = [{city: 'München'}, {city: 'Berlin'}];
        var expected = {'München': 1, 'Berlin': 1};

        var cityList = new CityList(addresses);
        var list = cityList.getList();
        expect(list).toEqual(expected);
    });

    it('should support multiple adresses with the same city', function() {
        var addresses = [{city: 'München'}, {city: 'München'}, {city: 'Berlin'}];
        var expected = {'München': 2, 'Berlin': 1};

        var cityList = new CityList(addresses);
        var list = cityList.getList();
        expect(list).toEqual(expected);
    });
});
