describe('game Over', function() {
it('should work without an exception if player is in board', function() {
    var player = new Player();
    player.snake = [{x: 4, y: 4}];
    player.board = {height: 10, width: 10};

    expect(player.gameOver.bind(player)).not.toThrow();
});

it('should throw an exception if the player is on the left', function() {
    var player = new Player();
    player.snake = [{x: -1, y: 4}];
    player.board = {height: 10, width: 10};

    expect(player.gameOver.bind(player)).toThrow(new Error('Out of bounds'));
});

it('should throw an exception if the snake eats itself', function() {
    var player = new Player();
    player.snake = [{x: 1, y: 1}, {x: 2, y: 1}, {x: 1, y: 1}];
    player.board = {height: 10, width: 10};

    expect(player.gameOver.bind(player)).toThrow(new Error('Snake ate itself'));
});
});