var fs = require('fs');

function CsvToObj() {};

CsvToObj.prototype.transform = function(string, keys) {
    var result = {};

    var properties = string.split(';');

    for (var i = 0; i < keys.length; i++) {
        if (properties[i] === '') {
            continue;
        }
        result[keys[i]] = properties[i];
    }

    return result;
};

CsvToObj.prototype.convert = function(content) {
    var lines = content.split('\n');
    var headers = lines.shift().split(';');
    var result = [];
    lines.forEach(function(value) {
        result.push(this.transform(value, headers));
    }.bind(this));
    return result;
};

CsvToObj.prototype.run = function(filename, cb) {
    fs.readFile(filename, 'utf-8', function(err, data) {
        var objData = this.convert(data);
        cb(objData);
    }.bind(this));
};

module.exports = CsvToObj;