var mockery = require('mockery');
var expect = require('expect.js');


var fsMock = {
    readFile: function(path, encoding, cb) {
        var content = 'Hello World!';
        cb(null, content);
    }
};
mockery.registerMock('fs', fsMock);
mockery.enable();

var fs = require('fs');

describe('mockery', function() {
    it('should intercept fs reads', function() {
        fs.readFile('myFile', 'utf-8', function(err, data) {
            expect(data).to.eql('Hello World!');
        });
    });
});

