var nock = require('nock');
var http = require('http');
var expect = require('expect.js');

describe('nock', function() {
    it('should intercept a request', function() {
        nock('http://www.google.de')
            .get('/')
            .reply(500, 'Hello I am not Google!');

        var request = http.get('http://www.google.de:80', function(res) {
            res.on('readable', function() {
                var chunk;
                var content = '';
                res.setEncoding('utf8');
                while (undefined !== (chunk = res.read())) {
                    content += chunk;
                }

                expect(content).to.eql('Hello I am not Google!');
            });
        });
    });
});
